-- ----------------------------
-- 用户表
-- ----------------------------
CREATE TABLE user
(
    id          INTEGER,
    username    TEXT NOT NULL,
    password    TEXT NOT NULL,
    avatar      TEXT    DEFAULT '',
    role        TEXT NOT NULL,
    status      INTEGER DEFAULT 0, -- 状态; 1 启用; 2 禁用;
    create_time INTEGER DEFAULT 0,
    update_time INTEGER DEFAULT 0,
    delete_time INTEGER DEFAULT 0,
    PRIMARY KEY (id AUTOINCREMENT),
    UNIQUE (username)
);
INSERT INTO user (username, password, role)
values ('', '', '');
delete
from user
where username = '';
UPDATE SQLITE_SEQUENCE
SET seq =99
WHERE name = 'user';

-- ----------------------------
-- 登陆表
-- ----------------------------
CREATE TABLE login_log
(
    id             INTEGER,
    user_id        INTEGER NOT NULL,
    token          TEXT    DEFAULT '', -- 登录 token
    resource_token TEXT    DEFAULT '', -- 资源 token
    refresh_token  TEXT    DEFAULT '', -- 刷新 token
    status         INTEGER DEFAULT 0,  -- 状态; 1 登录成功; 2 退出登录;
    create_time    INTEGER DEFAULT 0,
    update_time    INTEGER DEFAULT 0,
    delete_time    INTEGER DEFAULT 0,
    PRIMARY KEY (id AUTOINCREMENT)
);
INSERT INTO login_log (user_id)
values (0);
delete
from login_log
where user_id = 0;
UPDATE SQLITE_SEQUENCE
SET seq =99
WHERE name = 'login_log';

-- ----------------------------
-- 摄像头
-- ----------------------------
CREATE TABLE camera
(
    id          INTEGER,
    title       TEXT NOT NULL,
    pull_url    TEXT NOT NULL,
    push_url    TEXT    DEFAULT '',
    model       TEXT    DEFAULT '',
    status      INTEGER DEFAULT 0, -- 状态; 1 启用; 2 禁用;
    create_time INTEGER DEFAULT 0,
    update_time INTEGER DEFAULT 0,
    delete_time INTEGER DEFAULT 0,
    PRIMARY KEY (id AUTOINCREMENT)
);
INSERT INTO camera (title, pull_url)
values ('', '');
delete
from camera
where pull_url = '';
UPDATE SQLITE_SEQUENCE
SET seq =99
WHERE name = 'camera';
